The LLDB Debugger

# Continuous Integraton

The following LLVM buildbots build and test LLDB trunk:

- LLDB Ubuntu 14.04 x86_64 (CMake, clang-3.5+/gcc-4.8, i386/x86_64)
- LLDB Ubuntu 14.04 x86_64->Android (CMake, gcc-4.9 arm/arm64/x86)
- LLDB Mac OS X 10.9.5 x86_64 (Xcode)
- LLDB Windows Server 2008 x86 (CMake, MSVS 2013, Windows SDK 8.1, no tests)
- LLDB Windows 7 x86 (CMake, MSVS 2013, Windows SDK 8.1, no tests)
- LLDB Ubuntu 14.04 x86_64 build (automake, Clang 3.4, VMware Workstation)
- LLDB FreeBSD x86_64 (CMake)

# Building LLDB

- Building LLDB on Windows
- Building LLDB on Mac OSX
- Building LLDB on Linux and FreeBSD

# Building LLDB on Windows

## Required Dependencies

- Visual Studio 2012 or greater
- Windows SDK 8.0 or higher
- Python 2.7. Note that you must compile Python from source. See Preliminaries for more information.
- Ninja build tool (strongly recommended)
- GnuWin32
- SWIG for Windows

## Preliminaries

This section describes how to set up your system and install the required dependencies such that they can be found when needed during the build process. The steps outlined here only need to be performed once.

1. Install Visual Studio and the Windows SDK.

2. Build Python from source using the solution file supplied with the Python 2.7 source distribution.

   Because LLDB functionality is compiled into a Python extension module, the extension module must be compiled with the same version of Visual Studio that Python itself was compiled with. The binary release of Python 2.7 is compiled with Visual Studio 2008, so it is incompatible with linking against LLDB.

   Note that if you plan to do both debug and release builds of LLDB, you will need to compile both debug and release builds of Python. The same applies if you plan to build both x86 and x64 configurations of LLDB

3. Copy <python src dir>\PC\pyconfig.h to <python src dir>\Include.

   This is necessary because pyconfig.h is a hand-maintained file which is platform specific, so multiple copies of this file are included with each source distribution. It appears to be up to the person building Python to move the correct version of pyconfig.h to the Include folder.

4. Run lldb/scripts/install_custom_python.py so to "install" your custom build of Python to a canonical directory structure.

5. Install GnuWin32, making sure <GnuWin32 install dir>\bin is added to your PATH environment variable.

6. Install SWIG for Windows, making sure <SWIG install dir> is added to your PATH environment variable.

## Building LLDB

Any command prompt from which you build LLDB should have a valid Visual Studio environment setup. This means you should run vcvarsall.bat or open an appropriate Visual Studio Command Prompt corresponding to the version you wish to use.

Finally, when you are ready to build LLDB, generate CMake with the following command line:

`cmake -G Ninja <cmake variables> <path to root of llvm src tree>`

and run `ninja` to build LLDB. Information about running the LLDB test suite can be found on the test page.

Following is a description of some of the most important CMake variables which you are likely to encounter. A variable `FOO` is set by adding `-DFOO=value` to the CMake command line.

- LLDB_TEST_DEBUG_TEST_CRASHES (Default=0): If set to 1, will cause Windows to generate a crash dialog whenever lldb.exe or the python extension module crashes while running the test suite. If set to 0, LLDB will silently crash. Setting to 1 allows a developer to attach a JIT debugger at the time of a crash, rather than having to reproduce a failure or use a crash dump.
- PYTHON_HOME (Required): Path the folder you specified in the --dest argument to install_custom_python.py. Note that install_custom_python.py will create x86 and x64 subdirectories under this folder. PYTHON_HOME should refer to the correct architecture-specific folder.
- LLDB_RELOCATABLE_PYTHON (Default=0): When this is 0, LLDB will bind statically to the location specified in the PYTHON_HOME CMake variable, ignoring any value of PYTHONHOME set in the environment. This is most useful for developers who simply want to run LLDB after they build it. If you wish to move a build of LLDB to a different machine where Python will be in a different location, setting LLDB_RELOCATABLE_PYTHON to 1 will cause Python to use its default mechanism for finding the python installation at runtime (looking for installed Pythons, or using the PYTHONHOME environment variable if it is specified).

# Building LLDB on Mac OS X

Building on Mac OS X is as easy as downloading the code and building the Xcode project or workspace:

## Preliminaries

- XCode 4.3 or newer requires the "Command Line Tools" component (XCode->Preferences->Downloads->Components).
- Mac OS X Lion or newer requires installing Swig.

## Building LLDB

- Download the lldb sources.
- Follow the code signing instructions in lldb/docs/code-signing.txt
- In Xcode 3.x: lldb/lldb.xcodeproj, select the lldb-tool target, and build.
- In Xcode 4.x: lldb/lldb.xcworkspace, select the lldb-tool scheme, and build.

# Building LLDB on Linux and FreeBSD

This document describes the steps needed to compile LLDB on most Linux systems, and FreeBSD.

## Preliminaries

LLDB relies on many of the technologies developed by the larger LLVM project. In particular, it requires both Clang and LLVM itself in order to build. Due to this tight integration the Getting Started guides for both of these projects come as prerequisite reading:

- LLVM
- Clang

Supported compilers for building LLDB on Linux include:

- Clang 3.2
- GCC 4.6.2 (later versions should work as well)

It is recommended to use libstdc++ 4.6 (or higher) to build LLDB on Linux, but using libc++ is also known to work.

On FreeBSD the base system Clang and libc++ may be used to build LLDB, or the GCC port or package.

In addition to any dependencies required by LLVM and Clang, LLDB needs a few development packages that may also need to be installed depending on your system. The current list of dependencies are:

- Swig
- libedit (Linux only)
- Python

So for example, on a Fedora system one might run:

`> yum install swig python-devel libedit-devel`

On a Debian or Ubuntu system one might run:

`> sudo apt-get install build-essential subversion swig python2.7-dev libedit-dev libncurses5-dev`

or

`> sudo apt-get build-dep lldb-3.3 # or lldb-3.4`

On FreeBSD one might run:

`> pkg install swig python`

If you wish to build the optional reference documentation, additional dependencies are required:

- Graphviz (for the 'dot' tool).
- doxygen (only if you wish to build the C++ API reference)
- epydoc (only if you wish to build the Python API reference)

To install the prerequisites for building the documentation (on Debian/Ubuntu) do:

`
> sudo apt-get install doxygen graphviz
> sudo pip install epydoc # or install package python-epydoc`

## Building LLDB

We first need to checkout the source trees into the appropriate locations. Both Clang and LLDB build as subprojects of LLVM. This means we will be checking out the source for both Clang and LLDB into the `tools` subdirectory of LLVM. We will be setting up a directory hierarchy looking something like this:

                      llvm
                      |
                      `-- tools
                          |
                          +-- clang
                          |
                          `-- lldb

For reference, we will call the root of the LLVM project tree `$llvm`, and the roots of the Clang and LLDB source trees `$clang` and `$lldb` respectively.

Change to the directory where you want to do development work and checkout LLVM:

`> svn co http://llvm.org/svn/llvm-project/llvm/trunk llvm`

Now switch to LLVM’s tools subdirectory and checkout both Clang and LLDB:

`> cd $llvm/tools
> svn co http://llvm.org/svn/llvm-project/cfe/trunk clang
> svn co http://llvm.org/svn/llvm-project/lldb/trunk lldb`

In general, building the LLDB trunk revision requires trunk revisions of both LLVM and Clang.

It is highly recommended that you build the system out of tree. Create a second build directory and configure the LLVM project tree to your specifications as outlined in LLVM’s Getting Started Guide. A typical build procedure might be:

`> cd $llvm/..
> mkdir build
> cd build`

## To build with CMake

Using CMake is documented on the Building LLVM with CMake page. Building LLDB is possible using one of the following generators:

- Ninja
- Unix Makefiles

### Using CMake + Ninja

Ninja is the fastest way to build LLDB! In order to use ninja, you need to have recent versions of CMake and ninja on your system. To build using ninja:

`> cmake .. -G Ninja
> ninja lldb
> ninja check-lldb`

### Using CMake + Unix Makefiles

If you do not have Ninja, you can still use CMake to generate Unix Makefiles that build LLDB:

`> cmake ..
> make
> make check-lldb`

## To build with autoconf

If you do not have CMake, it is still possible to build LLDB using the autoconf build system. If you are using Clang or GCC 4.8+, run:

`> $llvm/configure
> make`

If you are building with a GCC that isn't the default gcc/g++, like gcc-4.9/g++-4.9

`> $llvm/configure CC=gcc-4.9 CXX=g++-4.9
> make CC=gcc-4.9 CXX=g++-4.9`

If you are running in a system that doesn't have a lot of RAM (less than 4GB), you might want to disable debug symbols by specifying DEBUG_SYMBOLS=0 when running make. You will know if you need to enable this because you will fail to link clang (the linker will get a SIGKILL and exit with status 9).

`> make DEBUG_SYMBOLS=0`

To run the LLDB test suite, run:

`
> make -C tools/lldb/test`

Note that once both LLVM and Clang have been configured and built it is not necessary to perform a top-level `make` to rebuild changes made only to LLDB. You can run `make` from the `build/tools/lldb` subdirectory as well.

If you wish to build with libc++ instead of libstdc++ (the default), run configure with the `--enable-libcpp` flag.

If you wish to build a release version of LLDB, run configure with the `--enable-optimized` flag.

## Building API reference documentation

LLDB exposes a C++ as well as a Python API. To build the reference documentation for these two APIs, ensure you have the required dependencies installed, and build the `lldb-python-doc` and `lldb-cpp-doc` CMake targets.

The output HTML reference documentation can be found in `<build-dir>/tools/lldb/docs/`.

## Additional Notes

LLDB has a Python scripting capability and supplies its own Python module named `lldb`. If a script is run inside the command line `lldb` application, the Python module is made available automatically. However, if a script is to be run by a Python interpreter outside the command line application, the `PYTHONPATH` environment variable can be used to let the Python interpreter find the `lldb` module.

The correct path can be obtained by invoking the command line `lldb` tool with the -P flag:

`> export PYTHONPATH=`$llvm/build/Debug+Asserts/bin/lldb -P``

If you used a different build directory or made a release build, you may need to adjust the above to suit your needs. To test that the lldb Python module is built correctly and is available to the default Python interpreter, run:

`> python -c 'import lldb'`

## Cross-compiling LLDB

In order to debug remote targets running different architectures than your host, you will need to compile LLDB (or at least the server component) for the target. While the easiest solution is to just compile it locally on the target, this is often not feasable, and in these cases you will need to cross-compile LLDB on your host.

Cross-compilation is often a daunting task and has a lot of quirks which depend on the exact host and target architectures, so it is not possible to give a universal guide which will work on all platforms. However, here we try to provide an overview of the cross-compilation process along with the main things you should look out for.

First, you will need a working toolchain which is capable of producing binaries for the target architecture. Since you already have a checkout of clang and lldb, you can compile a host version of clang in a separate folder and use that. Alternatively you can use system clang or even cross-gcc if your distribution provides such packages (e.g., `g++-aarch64-linux-gnu` on Ubuntu). On Android, a working toolchain can be produced by downloading the Android NDK and running the contained `make-standalone-toolchain.sh` script.

Next, you will need a copy of the required target headers and libraries on your host. The libraries can be usually obtained by copying from the target machine, however the headers are often not found there, especially in case of embedded platforms. In this case, you will need to obtain them from another source, either a cross-package if one is available, or cross-compiling the respective library from source. Fortunately the list of LLDB dependencies is not big and if you are only interested in the server component, you can reduce this even further by passing the appropriate cmake options, such as:

`-DLLDB_DISABLE_LIBEDIT=1
-DLLDB_DISABLE_CURSES=1
-DLLDB_DISABLE_PYTHON=1
-DLLVM_ENABLE_TERMINFO=0`

In this case you, will often not need anything other than the standard C and C++ libraries.

In the case of Android, all required headers and libraries are provided by the aforementioned `make-standalone-toolchain.sh` script.

Once all of the dependencies are in place, it's just a matter of configuring the build system with the locations and arguments of all the necessary tools. The most important cmake options here are:

CMAKE_CROSSCOMPILING
  Set to 1 to enable cross-compilation.
CMAKE_LIBRARY_ARCHITECTURE
  Affects the cmake search path when looking for libraries. You may need to set this to your architecture triple if you do not specify all your include and library paths explicitly.
CMAKE_C_COMPILER, CMAKE_CXX_COMPILER
  C and C++ compilers for the target architecture
CMAKE_C_FLAGS, CMAKE_CXX_FLAGS
  The flags for the C and C++ target compilers. You may need to specify the exact target cpu and abi besides the include paths for the target headers.
CMAKE_EXE_LINKER_FLAGS
  The flags to be passed to the linker. Usually just a list of library search paths referencing the target libraries.
LLVM_TABLEGEN, CLANG_TABLEGEN
  Paths to llvm-tblgen and clang-tblgen for the host architecture. If you already have built clang for the host, you can point these variables to the executables in your build directory. If not, you will need to build the llvm-tblgen and clang-tblgen host targets at least.
LLVM_HOST_TRIPLE
  The triple of the system that lldb (or lldb-server) will run on. Not setting this (or setting it incorrectly) can cause a lot of issues with remote debugging as a lot of the choices lldb makes depend on the triple reported by the remote platform.

You can of course also specify the usual cmake options like CMAKE_BUILD_TYPE, etc.

### Example 1: Cross-compiling for linux arm64 on Ubuntu host

Ubuntu already provides the packages necessary to cross-compile LLDB for arm64. It is sufficient to install pacakges gcc-aarch64-linux-gnu, g++-aarch64-linux-gnu, binutils-aarch64-linux-gnu. Then it is possible to prepare the cmake build with the following parameters:

`-DCMAKE_CROSSCOMPILING=1 \
-DCMAKE_C_COMPILER=aarch64-linux-gnu-gcc \
-DCMAKE_CXX_COMPILER=aarch64-linux-gnu-g++ \
-DLLVM_HOST_TRIPLE=aarch64-unknown-linux-gnu \
-DLLVM_TABLEGEN=<path-to-host>/bin/llvm-tblgen \
-DCLANG_TABLEGEN=<path-to-host>/bin/clang-tblgen \
-DLLDB_DISABLE_PYTHON=1 \
-DLLDB_DISABLE_LIBEDIT=1 \
-DLLDB_DISABLE_CURSES=1`

An alternative (and recommended) way to compile LLDB is with clang. Unfortunately, clang is not able to find all the include paths necessary for a successful cross-compile, so we need to help it with a couple of CFLAGS options. In my case it was sufficient to add the following arguments to CMAKE_C_FLAGS and CMAKE_CXX_FLAGS (in addition to changing CMAKE_C(XX)_COMPILER to point to clang compilers):

`-target aarch64-linux-gnu \
-I /usr/aarch64-linux-gnu/include/c++/4.8.2/aarch64-linux-gnu \
-I /usr/aarch64-linux-gnu/include`

If you wanted to build a full version of LLDB and avoid passing -DLLDB_DISABLE_PYTHON and other options, you would need to obtain the target versions of the respective libraries. The easiest way to achive this is to use the `qemu-debootstrap` utility, which can prepare a system image using qemu and chroot to simulate the target environment. Then you can install the necessary packages in this environment (python-dev, libedit-dev, etc.) and point your compiler to use them using the correct -I and -L arguments.

### Example 2: Cross-compiling for Android on Linux

All tools needed to build LLDB for android are available in the Android NDK. For example, we can produce an x86 toolchain along with all the libraries and headers by running

`./build/tools/make-standalone-toolchain.sh \
--platform=android-21 \
--toolchain=x86-4.9 \
--install-dir=$HOME/Toolchains/x86-android-toolchain`

from inside the unzipped NDK. Toolchains for other architectures can be produced in a similar manner.

For Android we provide a Android.cmake script which sets a lot of the required options automatically. A cmake build can therefore be prepared with the following parameters:

`-DCMAKE_TOOLCHAIN_FILE=cmake/platforms/Android.cmake \
-DANDROID_TOOLCHAIN_DIR=$HOME/Toolchains/x86-android-toolchain \
-DANDROID_ABI=x86 \
-DLLVM_HOST_TRIPLE=i386-unknown-linux-android \
-DLLVM_TABLEGEN=<path-to-host>/bin/llvm-tblgen \
-DCLANG_TABLEGEN=<path-to-host>/bin/clang-tblgen`

Note that the full LLVM build is not functional on android yet, so simply runing `ninja` will not work. You will need to manually specify the target you want to build: `lldb`, `lldb-server`, etc.